VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPicContainer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'------------------------------------------------------------------------------
'  Projekt     :  clsPicContainer
'  Typ         :  Klasse
'
'  Beschreibung:  eine Picturebox als Behlter fr ein verschiebbares Object
'                 wie Frame, Picturebox, das seinerseits als Behlter fr
'                 Controls dient
'
'  Autor       :  (c) peter.k.sauer@web.de
'  Created     :  05.2003
'  LastUpdate  :  14.06.2003
'-------------------------------------------------------------------------------



Option Explicit

Private WithEvents picContainer As PictureBox   'das Fenster
Attribute picContainer.VB_VarHelpID = -1
Private picMove As Object                       'Objectetrger
Private WithEvents Parentform As Form           'Mutterform
Attribute Parentform.VB_VarHelpID = -1

Private WithEvents HScrol As HScrollBar         'Scrollbars
Attribute HScrol.VB_VarHelpID = -1
Private WithEvents VScrol As VScrollBar
Attribute VScrol.VB_VarHelpID = -1
Private PicEdge As PictureBox                   'Ecke

Public Event Change()

Private InitDone As Boolean                     'fr Event Change
Private SettingValues As Boolean                'rekursiven Aufruf unterbinden

Private Type RECT
   Left As Single
   Top As Single
   Width As Single
   Height As Single
End Type

Private mvarStretchPicture As Boolean           'Symbol fr ziehen, Default = False
Private mvarContainerBackColor As Long          'BackColor Behlter, Default vbApplicationWorkspace
Private mvarScrollBarsWidthOrHeight As Single   'Breite bzw Hhe Scrollbar, Default 240
Private mvarScrollbarsAlways As Boolean         'Scrollbars permanent

Public Property Let ScrollbarsAlways(ByVal vData As Boolean)
    mvarScrollbarsAlways = vData
End Property

Public Property Get ScrollbarsAlways() As Boolean
    ScrollbarsAlways = mvarScrollbarsAlways
End Property

Public Property Let ScrollBarsWidthOrHeight(ByVal vData As Single)
    mvarScrollBarsWidthOrHeight = vData
End Property

Public Property Get ScrollBarsWidthOrHeight() As Single
    ScrollBarsWidthOrHeight = mvarScrollBarsWidthOrHeight
End Property

Public Property Let ContainerBackColor(ByVal vData As Long)
    mvarContainerBackColor = vData
End Property

Public Property Get ContainerBackColor() As Long
    ContainerBackColor = mvarContainerBackColor
End Property

Public Property Let StretchPicture(ByVal vData As Boolean)
      mvarStretchPicture = vData
      'Bild aktualisieren
      Refresh
End Property

Public Property Get StretchPicture() As Boolean
      StretchPicture = mvarStretchPicture
End Property


Public Sub Init(Parentbox As PictureBox, Containerbox As Object)
'initialisieren der notwendigen Elemente

      If InitDone Then
         Exit Sub
      End If

      'zuweisen der beiden Boxen
      Set picContainer = Parentbox
      Set picMove = Containerbox
      Set Parentform = Parentbox.Parent
      
      Set HScrol = LoadControl("VB.HScrollBar", "HScrol")
      Set VScrol = LoadControl("VB.VScrollBar", "VScrol")
      Set PicEdge = LoadControl("VB.PictureBox", "PicEdge")
      
      'Controls auf PicContainer setzen
      Set picMove.Container = picContainer
      Set HScrol.Container = picContainer
      Set VScrol.Container = picContainer
      Set PicEdge.Container = picContainer
      
      'PicMove einrichten
      With picMove
         .Top = 0
         .Left = 0
         .BorderStyle = 0
      End With
      
      'Scrollbars einrichten
      With HScrol
         .Min = 0
         .Max = 100
      End With
      
      With VScrol
         .Min = 0
         .Max = 100
      End With
      
      'Ecke
      With PicEdge
         .BorderStyle = 0
         .Height = 240
         .Width = 240
         .AutoRedraw = True
         .FontName = "Marlett"
         .FontSize = 12
      End With
      
      'visualisieren
      Refresh
      
      InitDone = True
End Sub

Public Sub Refresh()

      'Scrollbar positionieren
      SetScrollBars
      
      'Hintergrund Container
      picContainer.BackColor = mvarContainerBackColor
      
      'Breite berprfen, werden Scrollbars bentigt
      If picMove.Width <= (picContainer.ScaleWidth - VScrol.Width) Then
         picMove.Left = 0
         HScrol.Enabled = False
      ElseIf picMove.Left < (picContainer.ScaleWidth - picMove.Width - VScrol.Width) Then
         picMove.Left = (picContainer.ScaleWidth - picMove.Width - VScrol.Width)
         HScrol.Enabled = True
      Else
         HScrol.Enabled = True
      End If
      
      'Hhe berprfen, werden Scrollbars bentigt
      If picMove.Height <= (picContainer.ScaleHeight - HScrol.Height) Then
         picMove.Top = 0
         VScrol.Enabled = False
      ElseIf picMove.Top < (picContainer.ScaleHeight - picMove.Height - HScrol.Height) Then
         picMove.Top = (picContainer.ScaleHeight - picMove.Height - HScrol.Height)
         VScrol.Enabled = True
      Else
         VScrol.Enabled = True
      End If
      
      'Breite Verschiebebalken einstellen
      SetScrollValues
      
      If InitDone Then
         'Event auslsen
         RaiseEvent Change
      End If
End Sub

Private Sub SetScrollValues()

   Dim x As Single, x1 As Single
   
      'rekursiven Aufruf unterbinden
      SettingValues = True
   
      'Scrollbalken (Sprung)Breite
      With HScrol
         x = picContainer.ScaleWidth / picMove.Width
         x = Int(x * .Max)
         .SmallChange = x * 0.75
         .LargeChange = x * 1
         
         If picMove.Left = 0 Then
            .Value = 0
         End If
      End With
      
      With VScrol
         x = picContainer.ScaleHeight / picMove.Height
         x = Int(x * .Max)
         .SmallChange = x * 0.75
         .LargeChange = x * 1
         
         If picMove.Top = 0 Then
            .Value = 0
         End If
      End With
      
      HideScrollBars
      SetNewScrollBarsValues
      
      SettingValues = False
End Sub

Private Sub SetNewScrollBarsValues()
'Values fr Scrollbars einstellen

   Dim verschiebbar As Single
   Dim verschoben As Single
   Dim v As Single

      If (Not HScrol.Visible) Or (Not HScrol.Enabled) Then
         HScrol.Value = 0
      Else
         verschiebbar = picMove.Width - picContainer.ScaleWidth
         If VScrol.Visible Then
            verschiebbar = picMove.Width - (picContainer.ScaleWidth - VScrol.Width)
         End If
         verschoben = Abs(picMove.Left)
         v = verschoben * HScrol.Max / verschiebbar
         If v < 0 Then
            HScrol.Value = 0
         ElseIf v > HScrol.Max Then
            HScrol.Value = HScrol.Max
         Else
            HScrol.Value = v
         End If
      End If
         
      If (Not VScrol.Visible) Or (Not VScrol.Enabled) Then
         VScrol.Value = 0
      Else
         verschiebbar = picMove.Height - picContainer.ScaleHeight
         If HScrol.Visible Then
            verschiebbar = picMove.Height - (picContainer.ScaleHeight - HScrol.Height)
         End If
         verschoben = Abs(picMove.Top)
         v = verschoben * VScrol.Max / verschiebbar
         If v < 0 Then
            VScrol.Value = 0
         ElseIf v > VScrol.Max Then
            VScrol.Value = VScrol.Max
         Else
            VScrol.Value = v
         End If
      End If
End Sub

Private Sub HideScrollBars()
'nicht bentigte Scrollbars ausblenden
      
   Dim VNeeded As Boolean
   Dim HNeeded As Boolean
   
      'immer anzeigen ?
      If mvarScrollbarsAlways Then
         Exit Sub
      End If
   
      If picMove.Width > picContainer.ScaleWidth Then
         HNeeded = True
      End If
      If picMove.Height > picContainer.ScaleHeight Then
         VNeeded = True
      End If
      
      If Not HNeeded Then
         If VNeeded Then
            If picMove.Width > (picContainer.ScaleWidth - VScrol.Width) Then
               HNeeded = True
            End If
         End If
      End If
            
      If Not VNeeded Then
         If HNeeded Then
            If picMove.Height > (picContainer.ScaleHeight - HScrol.Height) Then
               VNeeded = True
            End If
         End If
      End If
      
      If Not HNeeded Then
         If VNeeded Then
            If picMove.Width > (picContainer.ScaleWidth - VScrol.Width) Then
               HNeeded = True
            End If
         End If
      End If
      
      
      PicEdge.Visible = True
      If Not HNeeded Then
         HScrol.Visible = False
         VScrol.Height = picContainer.ScaleHeight
         PicEdge.Visible = False
      End If
      If Not VNeeded Then
         VScrol.Visible = False
         HScrol.Width = picContainer.ScaleWidth
         PicEdge.Visible = False
      End If
End Sub

Private Sub SetScrollBars()

      'Scrollbars einstellen
      With HScrol
         .Height = mvarScrollBarsWidthOrHeight
         .Left = 0
         .Top = picContainer.ScaleHeight - .Height
         .Width = picContainer.ScaleWidth - VScrol.Width
      End With
      With VScrol
         .Width = mvarScrollBarsWidthOrHeight
         .Left = picContainer.ScaleWidth - .Width
         .Top = 0
         .Height = picContainer.ScaleHeight - HScrol.Height
      End With
      
      With PicEdge
         .Top = HScrol.Top
         .Left = HScrol.Width
         .BackColor = vbApplicationWorkspace
         .Cls
      End With
      
      If mvarStretchPicture Then
         With PicEdge
            .BackColor = vbButtonFace
            .CurrentX = 0
            .CurrentY = 0
            PicEdge.Print Chr(111)
         End With
      End If
      
      HScrol.Visible = True
      VScrol.Visible = True
      PicEdge.Visible = True
      
End Sub

Private Function LoadControl(LibraryName As String, _
                             objCtlName As String) As Control
'ein Control auf die Parentform beamen

   Dim i As Long
   Dim s As String
   Dim objCtl As Control
   
      i = 1
      Do
         On Error Resume Next
         'durch Anhngen einer Laufnummer eindeutige Bezeichner bilden
         s = objCtlName & i
         'Control in Parentform Collection aufnehmen
         Set objCtl = Parentform.Controls.Add(LibraryName, s, Parentform)
         If Err.Number = 0 Then
            'kein Fehler
            Exit Do
         ElseIf Err.Number = 727 Then
            'Control mit Bezeichner schon vorhanden, Laufnummer + 1
            i = i + 1
            Err.Clear
         Else
            'sonstiger Fehler
            FehlerAnzeige Err.Number, Err.Description, "clsFrameAsForm.LoadControl"
            Exit Do
         End If
      Loop
      
      'Control zuweisen
      Set LoadControl = objCtl
      Set objCtl = Nothing
End Function

Private Sub FehlerAnzeige(ErrNumber As Long, ErrDescription As String, _
                         Optional Titel As String = "")

   Dim Msg As String
   
      Msg = "Fehler " & ErrNumber & vbCrLf & vbCrLf & _
            ErrDescription
      MsgBox Msg, vbCritical, Titel
End Sub

Private Sub Class_Initialize()

      mvarStretchPicture = False                         'kein Ziehen Symbol
      mvarContainerBackColor = vbApplicationWorkspace    'Hintergrund Container
      mvarScrollBarsWidthOrHeight = 240                  'Breite bzw Hhe Scrollbar
      mvarScrollbarsAlways = False                       'ScrollBars permanent
End Sub

Private Sub Class_Terminate()
      
      'aufrumen
      Parentform.Controls.Remove HScrol
      Parentform.Controls.Remove VScrol
      Parentform.Controls.Remove PicEdge
      
      Set HScrol = Nothing
      Set VScrol = Nothing
      Set PicEdge = Nothing
      Set picMove = Nothing
      Set picContainer = Nothing
      Set Parentform = Nothing
End Sub

Private Sub HScrol_Change()

      HScrol_Scroll
End Sub

Private Sub HScrol_GotFocus()

      picContainer.SetFocus
End Sub

Private Sub HScrol_Scroll()

   Dim x As Single
   
      If SettingValues Then
         'rekursiven Aufruf unterbinden
         Exit Sub
      End If
   
      'Scrollen Horizontal
      If HScrol.Value = 0 Then
         picMove.Left = 0
      ElseIf HScrol.Value = HScrol.Max Then
         picMove.Left = picContainer.ScaleWidth - picMove.Width - VScrol.Width
      Else
         x = HScrol.Value / HScrol.Max
         picMove.Left = (picContainer.ScaleWidth - picMove.Width - VScrol.Width) * x
      End If
      
      RaiseEvent Change
End Sub

Private Sub Parentform_Resize()

      Refresh
End Sub

Private Sub VScrol_Change()

      VScrol_Scroll
End Sub

Private Sub VScrol_GotFocus()

      picContainer.SetFocus
End Sub

Public Function IsFullVisible(Ctl As Control) As Boolean
'prft, ob ein Control sichtbar ist

   Dim R As RECT

      R = GetVisibleArea
      
      IsFullVisible = True
      If R.Left > Ctl.Left Then
         IsFullVisible = False
      ElseIf (Ctl.Left + Ctl.Width) > (R.Left + R.Width) Then
         IsFullVisible = False
      ElseIf R.Top > Ctl.Top Then
         IsFullVisible = False
      ElseIf (Ctl.Top + Ctl.Height) > (R.Top + R.Height) Then
         IsFullVisible = False
      End If
End Function

Public Sub EnsureVisible(Ctl As Control)
'ein Control sichtbar machen durch Verschieben

   Dim R As RECT
   Dim x As Single

      If IsFullVisible(Ctl) Then
         Exit Sub
      End If
         
      R = GetVisibleArea
      'ist der rechte Rand sichtbar
      x = (Ctl.Left + Ctl.Width) - (R.Left + R.Width)
      If x > 0 Then
         x = R.Left + x
         If x > 0 Then
            picMove.Left = x * -1
            Refresh
            R = GetVisibleArea
         End If
      End If
      'ist der linke Rand sichtbar
      x = R.Left - Ctl.Left
      If x > 0 Then
         x = R.Left - x
         If x > 0 Then
            picMove.Left = x * -1
            Refresh
            R = GetVisibleArea
         End If
      End If
      'ist der untere Rand sichtbar
      x = (Ctl.Top + Ctl.Height) - (R.Top + R.Height)
      If x > 0 Then
         x = R.Top + x
         If x > 0 Then
            picMove.Top = x * -1
            Refresh
            R = GetVisibleArea
         End If
      End If
      'ist der obere Rand sichtbar
      x = R.Top - Ctl.Top
      If x > 0 Then
         x = R.Top - x
         If x > 0 Then
            picMove.Top = x * -1
            Refresh
         End If
      End If
End Sub

Private Function GetVisibleArea() As RECT
'gibt den sichtbaren Bereich zurck

   Dim R As RECT
   
      R.Left = picMove.Left * -1
      R.Top = picMove.Top * -1
      R.Width = picContainer.ScaleWidth
      If VScrol.Visible Or VScrol.Enabled Then
         R.Width = R.Width - VScrol.Width
      End If
      R.Height = picContainer.ScaleHeight
      If HScrol.Visible Or HScrol.Enabled Then
         R.Height = R.Height - HScrol.Height
      End If

      GetVisibleArea = R
End Function

Private Sub VScrol_Scroll()

   Dim x As Single
   
      'Scrollen Vertikal
      If VScrol.Value = 0 Then
         picMove.Top = 0
      ElseIf VScrol.Value = VScrol.Max Then
         picMove.Top = picContainer.ScaleHeight - picMove.Height - HScrol.Height
      Else
         x = VScrol.Value / VScrol.Max
         picMove.Top = (picContainer.ScaleHeight - picMove.Height - HScrol.Height) * x
      End If
      
      RaiseEvent Change
End Sub



