Attribute VB_Name = "modMain"
Option Explicit


Private Type BITMAP
   bmType As Long
   bmWidth As Long
   bmHeight As Long
   bmWidthBytes As Long
   bmPlanes As Integer
   bmBitsPixel As Integer
   bmBits As Long
End Type

Private Type PrintOptionsType
   Init As Boolean
   Printer As Long
   Format As Long
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
   FontName As Long
   FontSize As Long
   FontBold As Long
   FontItalic As Long
   FontUnderline As Long
   Orientation As Long
   Zoom As String
   Caption As Long
   Datum As Long
End Type
   
'Einstellungen fr drucken
Public PrintOptions As PrintOptionsType

Public Declare Function GetObject Lib "gdi32" Alias _
        "GetObjectA" (ByVal hObject As Long, ByVal nCount As _
        Long, lpObject As Any) As Long

'die Grsse einer .bmp Datei aus einer BitMap berechnen
Public Function BitmapFileLen(Pic As StdPicture) As Long

    Dim bmp As BITMAP
    Dim Result As Long
    
      Result = GetObject(Pic, Len(bmp), bmp)
      Debug.Print bmp.bmBitsPixel
      BitmapFileLen = bmp.bmWidth * Abs(bmp.bmHeight) * 3 + 54
End Function


Public Sub FehlerAnzeige(ErrNumber As Long, ErrDescription As String, _
                         Optional Titel As String = "")

   Dim Msg As String
   
      Msg = "Fehler " & ErrNumber & vbCrLf & vbCrLf & _
            ErrDescription
      If Len(Titel) > 0 Then
         MsgBox Msg, vbCritical, Titel
      Else
         MsgBox Msg, vbCritical
      End If
End Sub

Public Function GetStdPictureWidth(MeFrm As Form, Pic As StdPicture, _
                                   Optional ScaleMode As Long = vbPixels) _
                                   As Single
   Dim w As Single
   
      'Breite eines Bildes ermitteln
      w = MeFrm.ScaleX(Pic.Width, vbHimetric, ScaleMode)
      GetStdPictureWidth = FormatNumber(w, 0)
End Function

Public Function GetStdPictureHeight(MeFrm As Form, Pic As StdPicture, _
                                    Optional ScaleMode As Long = vbPixels) _
                                    As Single
   Dim h As Single

      'Hhe eines Bildes ermitteln
      h = MeFrm.ScaleY(Pic.Height, vbHimetric, ScaleMode)
      GetStdPictureHeight = FormatNumber(h, 0)
End Function

'liefert den AppPath mit oder ohne abschliessenden BackSlash
Public Function AppPath(Optional NoBackSlash As Boolean = False) As String

   Static Path As String
   
      If Len(Path) = 0 Then
         Path = App.Path
         If Right(Path, 1) <> "\" Then
            Path = Path & "\"
         End If
      End If
      
      If NoBackSlash Then
         AppPath = Left(Path, Len(Path) - 1)
      Else
         AppPath = Path
      End If
End Function

