Attribute VB_Name = "modPrintDialog"
Option Explicit

'API's
Private Declare Function ClosePrinter Lib "winspool.drv" _
                        (ByVal hPrinter As Long) As Long
Private Declare Function OpenPrinter Lib "winspool.drv" _
                        Alias "OpenPrinterA" _
                        (ByVal pPrinterName As String, _
                        phPrinter As Long, _
                        pDefault As PRINTER_DEFAULTS) As Long
Private Declare Function PrinterProperties Lib "winspool.drv" _
                        (ByVal hWnd As Long, _
                         ByVal hPrinter As Long) As Long
Private Declare Function DocumentProperties Lib "winspool.drv" _
                         Alias "DocumentPropertiesA" _
                        (ByVal hWnd As Long, _
                         ByVal hPrinter As Long, _
                         ByVal pDeviceName As String, _
                         pDevModeOutput As Long, _
                         pDevModeInput As Long, _
                         ByVal fMode As Long) As Long
Private Declare Function GetPrinter Lib "winspool.drv" _
                         Alias "GetPrinterA" _
                         (ByVal hPrinter As Long, _
                         ByVal Level As Long, _
                         pPrinter As Any, _
                         ByVal cbBuf As Long, _
                         pcbNeeded As Long) As Long
Private Declare Function SetPrinter Lib "winspool.drv" _
                        Alias "SetPrinterA" _
                        (ByVal hPrinter As Long, _
                        ByVal Level As Long, _
                        pPrinter As Any, _
                        ByVal Command As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" _
                        Alias "RtlMoveMemory" _
                        (hpvDest As Any, _
                        hpvSource As Any, _
                        ByVal cbCopy As Long)
                        
'Konstanten in der DevMode-Struktur
Private Const CCHDEVICENAME = 32
Private Const CCHFORMNAME = 32

'hier knnten ber auslesen und schreiben die Eigenschaften
'per Code eingestellt werden
Private Type DevMode
       dmDeviceName(0 To CCHDEVICENAME) As Byte
       dmSpecVersion As Integer
       dmDriverVersion As Integer
       dmSize As Integer
       dmDriverExtra As Integer
       dmFields As Long
       dmOrientation As Integer
       dmPaperSize As Integer
       dmPaperLength As Integer
       dmPaperWidth As Integer
       dmScale As Integer
       dmCopies As Integer
       dmDefaultSource As Integer
       dmPrintQuality As Integer
       dmColor As Integer
       dmDuplex As Integer
       dmYResolution As Integer
       dmTTOption As Integer
       dmCollate As Integer
       dmFormName As String * CCHFORMNAME
       dmLogPixels As Integer
       dmBitsPerPel As Long
       dmPelsWidth As Long
       dmPelsHeight As Long
       dmDisplayFlags As Long
       dmDisplayFrequency As Long
       dmICMMethod As Long        '// Windows 95 only
       dmICMIntent As Long        ' // Windows 95 only
       dmMediaType As Long        ' // Windows 95 only
       dmDitherType As Long       ' // Windows 95 only
       dmReserved1 As Long        ' // Windows 95 only
       dmReserved2 As Long        ' // Windows 95 only
End Type
                        

' Constants for DocumentProperties
Public Const DM_UPDATE = 1
Public Const DM_COPY = 2
Public Const DM_PROMPT = 4
Public Const DM_MODIFY = 8
Public Const DM_IN_BUFFER = DM_MODIFY
Public Const DM_OUT_BUFFER = DM_COPY
Public Const DM_IN_PROMPT = DM_PROMPT

Public Const IDOK = 1
Public Const IDCancel = 2

Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const PRINTER_ACCESS_ADMINISTER = &H4
Public Const PRINTER_ACCESS_USE = &H8
Public Const PRINTER_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED Or _
                                   PRINTER_ACCESS_ADMINISTER Or _
                                   PRINTER_ACCESS_USE)

Private Type PRINTER_DEFAULTS
   pDatatype As Long             'Pointer auf String
   pDevMode As Long              'Pointer auf DEVMODE-Structure
   DesiredAccess As Long
End Type

Private Type PRINTER_INFO_2
   pServerName As Long           'String
   pPrinterName As Long          'String
   pShareName As Long            'String
   pPortName As Long             'String
   pDriverName As Long           'String
   pComment As Long              'String
   pLocation As Long             'String
   pDevMode As Long              'DEVMODE
   pSepFile As Long              'String
   pPrintProcessor As Long       'String
   pDatatype As Long             'String
   pParameters As Long           'String
   pSecurityDescriptor As Long   'Pointer auf SECURITY_DESCRIPTOR
   Attributes As Long
   Priority As Long
   DefaultPriority As Long
   StartTime As Long
   UntilTime As Long
   Status As Long
   cJobs As Long
   AveragePPM As Long
End Type

'Printereigenschaften:
Public Function PropertieDLG(hWnd As Long, strPrinter As String) As Long
   
   Dim rv As Long
   Dim hPrinter As Long
   Dim pd As PRINTER_DEFAULTS
       
      pd.pDatatype = 0
      pd.pDevMode = 0
      pd.DesiredAccess = PRINTER_ALL_ACCESS

      If OpenPrinter(strPrinter, hPrinter, pd) = 0 Then
         PropertieDLG = Err.LastDllError
         FehlerAnzeige Err.LastDllError, "Fehler beim Aufruf der" & vbCrLf & _
                                         "Druckerproperties" & _
                                         Space(15), "PropertieDLG"
         Exit Function
      End If
      
      rv = PrinterProperties(hWnd, hPrinter)
      ClosePrinter hPrinter
End Function

'Dokumenteneigenschaften:
Public Function DocumentDLG(hWnd As Long, strPrinter As String) As Long
   
   Dim rv As Long
   Dim hPrinter As Long
   Dim pd As PRINTER_DEFAULTS
   Dim pi2 As PRINTER_INFO_2
   Dim pd_buffer() As Long
   Dim Needed As Long

      pd.pDatatype = 0
      pd.pDevMode = 0
      pd.DesiredAccess = PRINTER_ALL_ACCESS
      
      If OpenPrinter(strPrinter, hPrinter, pd) = 0 Then
         DocumentDLG = Err.LastDllError
         FehlerAnzeige Err.LastDllError, "Fehler beim Aufruf der" & vbCrLf & _
                                         "Druckerdokumenteneingenschaften" & _
                                         Space(10), "DocumentDLG"
         Exit Function
      End If
      
      rv = GetPrinter(hPrinter, 2, ByVal 0&, 0, Needed)
      ReDim pd_buffer((Needed \ 4))
      rv = GetPrinter(hPrinter, 2, pd_buffer(0), Needed, Needed)
      
      Call CopyMemory(pi2, pd_buffer(0), Len(pi2))
      
      rv = DocumentProperties(hWnd, _
                              hPrinter, _
                              strPrinter, _
                              ByVal pi2.pDevMode, _
                              ByVal pi2.pDevMode, _
                              DM_IN_BUFFER Or _
                              DM_OUT_BUFFER Or _
                              DM_PROMPT)
      If rv = IDOK Then
         rv = SetPrinter(hPrinter, 2, pd_buffer(0), 0)
      End If
      
      ClosePrinter hPrinter
End Function


